Code

t7300: add test for clean with wildcard pathspec
[git.git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 USAGE='[  | save | list | show | apply | clear | create ]'
6 SUBDIRECTORY_OK=Yes
7 OPTIONS_SPEC=
8 . git-sh-setup
9 require_work_tree
10 cd_to_toplevel
12 TMP="$GIT_DIR/.git-stash.$$"
13 trap 'rm -f "$TMP-*"' 0
15 ref_stash=refs/stash
17 no_changes () {
18         git diff-index --quiet --cached HEAD -- &&
19         git diff-files --quiet
20 }
22 clear_stash () {
23         if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
24         then
25                 git update-ref -d $ref_stash $current
26         fi
27 }
29 create_stash () {
30         stash_msg="$1"
32         if no_changes
33         then
34                 exit 0
35         fi
37         # state of the base commit
38         if b_commit=$(git rev-parse --verify HEAD)
39         then
40                 head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
41         else
42                 die "You do not have the initial commit yet"
43         fi
45         if branch=$(git symbolic-ref -q HEAD)
46         then
47                 branch=${branch#refs/heads/}
48         else
49                 branch='(no branch)'
50         fi
51         msg=$(printf '%s: %s' "$branch" "$head")
53         # state of the index
54         i_tree=$(git write-tree) &&
55         i_commit=$(printf 'index on %s\n' "$msg" |
56                 git commit-tree $i_tree -p $b_commit) ||
57                 die "Cannot save the current index state"
59         # state of the working tree
60         w_tree=$( (
61                 rm -f "$TMP-index" &&
62                 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
63                 GIT_INDEX_FILE="$TMP-index" &&
64                 export GIT_INDEX_FILE &&
65                 git read-tree -m $i_tree &&
66                 git add -u &&
67                 git write-tree &&
68                 rm -f "$TMP-index"
69         ) ) ||
70                 die "Cannot save the current worktree state"
72         # create the stash
73         if test -z "$stash_msg"
74         then
75                 stash_msg=$(printf 'WIP on %s' "$msg")
76         else
77                 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
78         fi
79         w_commit=$(printf '%s\n' "$stash_msg" |
80                 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
81                 die "Cannot record working tree state"
82 }
84 save_stash () {
85         stash_msg="$1"
87         if no_changes
88         then
89                 echo >&2 'No local changes to save'
90                 exit 0
91         fi
92         test -f "$GIT_DIR/logs/$ref_stash" ||
93                 clear_stash || die "Cannot initialize stash"
95         create_stash "$stash_msg"
97         # Make sure the reflog for stash is kept.
98         : >>"$GIT_DIR/logs/$ref_stash"
100         git update-ref -m "$stash_msg" $ref_stash $w_commit ||
101                 die "Cannot save the current status"
102         printf >&2 'Saved "%s"\n' "$stash_msg"
105 have_stash () {
106         git rev-parse --verify $ref_stash >/dev/null 2>&1
109 list_stash () {
110         have_stash || return 0
111         git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
112         sed -n -e 's/^[.0-9a-f]* refs\///p'
115 show_stash () {
116         flags=$(git rev-parse --no-revs --flags "$@")
117         if test -z "$flags"
118         then
119                 flags=--stat
120         fi
121         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
123         w_commit=$(git rev-parse --verify "$s") &&
124         b_commit=$(git rev-parse --verify "$s^") &&
125         git diff $flags $b_commit $w_commit
128 apply_stash () {
129         git diff-files --quiet ||
130                 die 'Cannot restore on top of a dirty state'
132         unstash_index=
133         case "$1" in
134         --index)
135                 unstash_index=t
136                 shift
137         esac
139         # current index state
140         c_tree=$(git write-tree) ||
141                 die 'Cannot apply a stash in the middle of a merge'
143         # stash records the work tree, and is a merge between the
144         # base commit (first parent) and the index tree (second parent).
145         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
146         w_tree=$(git rev-parse --verify "$s:") &&
147         b_tree=$(git rev-parse --verify "$s^1:") &&
148         i_tree=$(git rev-parse --verify "$s^2:") ||
149                 die "$*: no valid stashed state found"
151         unstashed_index_tree=
152         if test -n "$unstash_index" && test "$b_tree" != "$i_tree"
153         then
154                 git diff-tree --binary $s^2^..$s^2 | git apply --cached
155                 test $? -ne 0 &&
156                         die 'Conflicts in index. Try without --index.'
157                 unstashed_index_tree=$(git-write-tree) ||
158                         die 'Could not save index tree'
159                 git reset
160         fi
162         eval "
163                 GITHEAD_$w_tree='Stashed changes' &&
164                 GITHEAD_$c_tree='Updated upstream' &&
165                 GITHEAD_$b_tree='Version stash was based on' &&
166                 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
167         "
169         if git-merge-recursive $b_tree -- $c_tree $w_tree
170         then
171                 # No conflict
172                 if test -n "$unstashed_index_tree"
173                 then
174                         git read-tree "$unstashed_index_tree"
175                 else
176                         a="$TMP-added" &&
177                         git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
178                         git read-tree --reset $c_tree &&
179                         git update-index --add --stdin <"$a" ||
180                                 die "Cannot unstage modified files"
181                         rm -f "$a"
182                 fi
183                 git status || :
184         else
185                 # Merge conflict; keep the exit status from merge-recursive
186                 status=$?
187                 if test -n "$unstash_index"
188                 then
189                         echo >&2 'Index was not unstashed.'
190                 fi
191                 exit $status
192         fi
195 # Main command set
196 case "$1" in
197 list)
198         shift
199         if test $# = 0
200         then
201                 set x -n 10
202                 shift
203         fi
204         list_stash "$@"
205         ;;
206 show)
207         shift
208         show_stash "$@"
209         ;;
210 save)
211         shift
212         save_stash "$*" && git-reset --hard
213         ;;
214 apply)
215         shift
216         apply_stash "$@"
217         ;;
218 clear)
219         clear_stash
220         ;;
221 create)
222         if test $# -gt 0 && test "$1" = create
223         then
224                 shift
225         fi
226         create_stash "$*" && echo "$w_commit"
227         ;;
228 *)
229         if test $# -eq 0
230         then
231                 save_stash && git-reset --hard
232         else
233                 usage
234         fi
235         ;;
236 esac